#include "align.h"

Align::Align( QWidget* parent, int anz )
    : QDialog( parent, "al", true, 0 )
{
    Anzahl = anz;
    resize( 450, 190 );
    setMinimumSize( QSize( 450, 190 ) );
    setMaximumSize( QSize( 450, 190 ) );
    if (Anzahl > 2)
    	{
    	setCaption( tr( "Distribute/Align" ) );
    	}
    else
    	{
    	setCaption( tr( "Align" ) );
    	}
    ButtonGroup1_2 = new QButtonGroup( this, "ButtonGroup1_2" );
    ButtonGroup1_2->setGeometry( QRect( 230, 14, 210, 120 ) ); 
    ButtonGroup1_2->setTitle( tr( "" ) );
    AbsVert = new QRadioButton( ButtonGroup1_2, "AbsVert" );
    AbsVert->setEnabled( FALSE );
    AbsVert->setGeometry( QRect( 20, 24, 62, 20 ) ); 
    AbsVert->setText( tr( "Dist.:" ) );
    AbsVert->setChecked(true);
    VerteilenV = new QRadioButton( ButtonGroup1_2, "VerteilenV" );
    VerteilenV->setEnabled( FALSE );
    VerteilenV->setGeometry( QRect( 20, 54, 146, 20 ) ); 
    VerteilenV->setText( tr( "Distribute evenly" ) );
    TextLabel1_2 = new QLabel( ButtonGroup1_2, "TextLabel1_2" );
    TextLabel1_2->setEnabled( FALSE );
    TextLabel1_2->setGeometry( QRect( 20, 84, 54, 20 ) );
    TextLabel1_2->setText( tr( "between:" ) );
    VartV = new QComboBox( true, ButtonGroup1_2, "VartV" );
    VartV->setEnabled( FALSE );
    VartV->setGeometry( QRect( 80, 83, 120, 22 ) );
    VartV->insertItem(tr("Top Sides"));
    VartV->insertItem(tr("Middles"));
    VartV->insertItem(tr("Bottom Sides"));
    VartV->setEditable(false);
    AVert = new QSpinBox( ButtonGroup1_2, "AVert" );
    AVert->setEnabled( FALSE );
    AVert->setGeometry( QRect( 85, 24, 80, 20 ) );
    AVert->setSuffix( tr( " pts" ) );
    AVert->setMaxValue( 1000 );
    AVert->setMinValue( -1000 );
    AVert->setValue( 0 );
    ButtonGroup1 = new QButtonGroup( this, "ButtonGroup1" );
    ButtonGroup1->setGeometry( QRect( 10, 14, 210, 120 ) ); 
    ButtonGroup1->setTitle( tr( "" ) );
    AbsHori = new QRadioButton( ButtonGroup1, "AbsHori" );
    AbsHori->setEnabled( FALSE );
    AbsHori->setGeometry( QRect( 20, 24, 62, 20 ) ); 
    AbsHori->setText( tr( "Dist.:" ) );
    AbsHori->setChecked(true);
    VerteilenH = new QRadioButton( ButtonGroup1, "VerteilenH" );
    VerteilenH->setEnabled( FALSE );
    VerteilenH->setGeometry( QRect( 20, 54, 146, 20 ) ); 
    VerteilenH->setText( tr( "Distribute evenly" ) );
    AHor = new QSpinBox( ButtonGroup1, "AHor" );
    AHor->setEnabled( FALSE );
    AHor->setGeometry( QRect( 85, 24, 80, 20 ) );
    AHor->setSuffix( tr( " pts" ) );
    AHor->setMaxValue( 1000 );
    AHor->setMinValue( -1000 );
    AHor->setValue( 0 );
    VartH = new QComboBox(true, ButtonGroup1, "VartH" );
    VartH->setEnabled( FALSE );
    VartH->setGeometry( QRect( 80, 83, 120, 22 ) );
    VartH->insertItem(tr("Left Sides"));
    VartH->insertItem(tr("Middles"));
    VartH->insertItem(tr("Right Sides"));
    VartH->setEditable(false);
		TextLabel1 = new QLabel( ButtonGroup1, "TextLabel1" );
    TextLabel1->setEnabled( FALSE );
    TextLabel1->setGeometry( QRect( 20, 84, 54, 20 ) );
    TextLabel1->setText( tr( "between:" ) );
    QWidget* privateLayoutWidget = new QWidget( this, "Layout2" );
    privateLayoutWidget->setGeometry( QRect( 40, 141, 370, 34 ) ); 
    Layout2 = new QHBoxLayout( privateLayoutWidget ); 
    Layout2->setSpacing( 6 );
    Layout2->setMargin( 0 );
    OKbutton = new QPushButton( privateLayoutWidget, "OKbutton" );
    OKbutton->setText( tr( "OK" ) );
    OKbutton->setDefault( TRUE );
    Layout2->addWidget( OKbutton );
    QSpacerItem* spacer = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    Layout2->addItem( spacer );
    ButtonApply = new QPushButton( privateLayoutWidget, "ButtonApply" );
    ButtonApply->setText( tr( "Apply" ) );
    ButtonApply->setEnabled(false);
    Layout2->addWidget( ButtonApply );
    QSpacerItem* spacer_2 = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    Layout2->addItem( spacer_2 );
    CancelB = new QPushButton( privateLayoutWidget, "CancelB" );
    CancelB->setText( tr( "Cancel" ) );
    Layout2->addWidget( CancelB );
    CheckV = new QCheckBox( this, "CheckV" );
    CheckV->setGeometry( QRect( 250, 6, 68, 20 ) ); 
    CheckV->setText( tr( "Vertical" ) );
    CheckH = new QCheckBox( this, "CheckH" );
    CheckH->setGeometry( QRect( 30, 6, 90, 20 ) ); 
    CheckH->setText( tr( "Horizontal" ) );

    // signals and slots connections
    connect( OKbutton, SIGNAL( clicked() ), this, SLOT( accept() ) );
    connect( CancelB, SIGNAL( clicked() ), this, SLOT( reject() ) );
    connect(ButtonApply, SIGNAL(clicked()), this, SLOT( slotApplyDiag()));
    connect( CheckV, SIGNAL( clicked() ), this, SLOT( AVerti() ) );
    connect( CheckH, SIGNAL( clicked() ), this, SLOT( AHori() ) );
    connect( AbsHori, SIGNAL( clicked() ), this, SLOT( DistHoriz() ) );
    connect( AbsVert, SIGNAL( clicked() ), this, SLOT( DistVert() ) );
    connect( VerteilenH, SIGNAL( clicked() ), this, SLOT( DistHoriz() ) );
    connect( VerteilenV, SIGNAL( clicked() ), this, SLOT( DistVert() ) );
}

/*  
 *  Destroys the object and frees any allocated resources
 */
Align::~Align()
{
    // no need to delete child widgets, Qt does it all for us
}

void Align::AVerti()
{
    if (CheckV->isChecked())
    	{
    	AbsVert->setEnabled( true );
    	if (Anzahl > 2)
    		{
    		VerteilenV->setEnabled( true );
    		}
    	VartV->setEnabled( true );
    	TextLabel1_2->setEnabled( true );
    	ButtonApply->setEnabled(true);
    	if (AbsVert->isChecked())
    		{
    		AVert->setEnabled( true );
    		}
    	}
    else
    	{
    	AbsVert->setEnabled( false );
    	VerteilenV->setEnabled( false );
    	VartV->setEnabled( false );
    	TextLabel1_2->setEnabled( false );
    	AVert->setEnabled( false );
    	if ((!CheckH->isChecked()) && (!CheckV->isChecked()))
    		{
    		ButtonApply->setEnabled(false);
    		}
    	}
}

void Align::DistHoriz()
{
    if (AbsHori->isChecked())
    	{
    	AHor->setEnabled( true );
    	}
    else
    	{
    	AHor->setEnabled( false );
    	}
}

void Align::DistVert()
{
    if (AbsVert->isChecked())
    	{
    	AVert->setEnabled( true );
    	}
    else
    	{
    	AVert->setEnabled( false );
    	}
}

void Align::AHori()
{
    if (CheckH->isChecked())
    	{
    	AbsHori->setEnabled( true );
    	if (Anzahl > 2)
    		{
    		VerteilenH->setEnabled( true );
    		}
    	VartH->setEnabled( true );
    	TextLabel1->setEnabled( true );
    	ButtonApply->setEnabled(true);
    	if (AbsHori->isChecked())
    		{
    		AHor->setEnabled( true );
    		}
    	}
    else
    	{
    	AbsHori->setEnabled( false );
    	VerteilenH->setEnabled( false );
    	VartH->setEnabled( false );
    	TextLabel1->setEnabled( false );
    	AHor->setEnabled( false );
    	if ((!CheckH->isChecked()) && (!CheckV->isChecked()))
    		{
    		ButtonApply->setEnabled(false);
    		}
    	}
}

void Align::slotApplyDiag()
{
	float xdp = float(AHor->value());
	bool xa = CheckH->isChecked();
	float ydp = float(AVert->value());
	bool ya = CheckV->isChecked();
	int xart = VartH->currentItem();
	int yart = VartV->currentItem();
	bool Vth = VerteilenH->isChecked();
	bool Vtv = VerteilenV->isChecked();
	emit ApplyDist(xa, ya, Vth, Vtv, xdp, ydp, xart, yart);
}
