#include "fontprefs.h"
#include <qhbox.h>

FontPrefs::FontPrefs( QWidget* parent,  SCFonts flist)
    : QDialog( parent, "fpre", true, 0 )
{
    resize( 590, 255 );
    setMinimumSize( QSize( 590, 255 ) );
    setMaximumSize( QSize( 590, 255 ) );
    setCaption( tr( "Global Fontsettings" ) );
		PushButton1 = new QPushButton( this, "PushButton1" );
    PushButton1->setGeometry( QRect( 10, 219, 90, 30 ) ); 
    PushButton1->setText( tr( "OK" ) );
		Table1 = new QTable( this, "Table1" );
    Table1->setGeometry( QRect( 10, 10, 570, 200 ) ); 
    Table1->setNumRows( flist.count() );
    Table1->setNumCols( 4 );
    SCFonts::Iterator it;
    int a = 0;
    for (it = flist.begin(); it != flist.end(); ++it)
    	{
    	Table1->setText(a, 0, it.key());
    	Table1->setText(a, 1, it.data().RealName);
    	QCheckBox *cp2 = new QCheckBox(this, "ps");
    	cp2->setText(tr("Postscript"));
    	cp2->setChecked(it.data().EmbedPS);
    	cp2->setBackgroundColor(white);
    	FlagsPS.append(cp2);
    	Table1->setCellWidget(a, 2, cp2);
    	Table1->setText(a, 3, it.data().Datei);
    	a++;
    	}
    Zeilen = a-1;
    Table1->adjustColumn(0);
    Table1->adjustColumn(1);
    Table1->setColumnWidth(2, 110);
    Table1->adjustColumn(3);
    Table1->sortColumn(0, 1, 1);
    Table1->setColumnMovingEnabled(false);
    Table1->setRowMovingEnabled(false);
    Table1->setSorting(false);
    Table1->setSelectionMode(QTable::NoSelection);
    Table1->setLeftMargin(0);
    Table1->verticalHeader()->hide();
    Header =  Table1->horizontalHeader();
    Header->setLabel(0, tr("QT-Name"));
    Header->setLabel(1, tr("Postscript-Name"));
    Header->setLabel(2, tr("Embed in:"));
    Header->setLabel(3, tr("Path to Fontfile"));
    Header->setMovingEnabled(false);
    Header->setResizeEnabled(false);

    PushButton1_2 = new QPushButton( this, "PushButton1_2" );
    PushButton1_2->setGeometry( QRect( 115, 219, 90, 30 ) ); 
    PushButton1_2->setText( tr( "Cancel" ) );
    PushButton1_2->setDefault( TRUE );

    // signals and slots connections
    connect( PushButton1_2, SIGNAL( clicked() ), this, SLOT( reject() ) );
    connect( PushButton1, SIGNAL( clicked() ), this, SLOT( accept() ) );
}

/*  
 *  Destroys the object and frees any allocated resources
 */
FontPrefs::~FontPrefs()
{
    // no need to delete child widgets, Qt does it all for us
}

