/***************************************************************************
                          hruler.cpp  -  description
                             -------------------
    begin                : Tue Apr 10 2001
    copyright            : (C) 2001 by Franz Schmid
    email                : Franz.Schmid@altmuehlnet.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "hruler.h"

Hruler::Hruler(QScrollView *pa, ScribusDoc *doc) : QWidget(pa)
{
	setBackgroundColor(QColor(255,255,255));
	doku = doc;
	rfont = font();
	rfont.setPointSize(9);
	offs = -10;
	Markp = 0;
	repX = FALSE;
}

Hruler::~Hruler(){
}

void Hruler::paintEvent(QPaintEvent *)
{
	int leng;
	int xx;
	float sc = doku->Scale;
	QPainter p;
	p.begin(this);
	p.translate(-offs, 0);
	if (repX)
		{
		p.setPen(red);
		p.setBrush(red);
		QPointArray cr;
		cr.setPoints(3, Markp, 9, Markp+2, 0, Markp-2, 0);
		p.drawPolygon(cr);
		p.end();
		repX = FALSE;
		return;
		}
	p.setBrush(black);
	p.setPen(black);
	p.setFont(rfont);
	p.scale(sc, 1.0);
	leng = qRound(QMAX(doku->PageB, float(width()/sc)))+30;
	p.drawLine(0, 24, leng, 24);
	for (xx = 0; xx <= leng; xx += 10)
		{
		if ((xx % 100) == 0)
			{
			p.drawLine(xx, 11, xx, 24);
			p.save();
			p.scale(1.0 / sc, 1.0);
			p.drawText((xx + 2) * sc, 17, QString::number(xx));
			p.restore();
			}
		else
			{
			p.drawLine(xx, 18, xx, 24);
			}
		}
}

/** Zeichnet den Pfeil */
void Hruler::Draw(int wo)
{
	repX = TRUE;
	Markp = wo;
	repaint(QRect(0, 0, width(), 9));
}
