/***************************************************************************
                          mpalette.cpp  -  description
                             -------------------
    begin                : Wed Apr 18 2001
    copyright            : (C) 2001 by Franz Schmid
    email                : Franz.Schmid@altmuehlnet.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "mpalette.h"
#include "fmitem.h"
#include "icons4.h"
#include "query.h"

Mpalette::Mpalette( QWidget* parent, SCFonts fo)
    : QDialog( parent, "Edit", 0, WStyle_Customize | WStyle_NoBorderEx)
{
		resize(491,31);
    setCaption(tr("Edit"));
    setMinimumSize(QSize(502,31));
    setMaximumSize(QSize(502,31));
    setFocusPolicy(ClickFocus);
    QFont fon = font();
    fon.setPointSize(10);
    QPalette pal;
    QColorGroup cg;
    cg.setColor( QColorGroup::Foreground, black );
    cg.setColor( QColorGroup::Button, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Light, white );
    cg.setColor( QColorGroup::Midlight, QColor( 233, 233, 233) );
    cg.setColor( QColorGroup::Dark, QColor( 105, 105, 105) );
    cg.setColor( QColorGroup::Mid, QColor( 140, 140, 140) );
    cg.setColor( QColorGroup::Text, black );
    cg.setColor( QColorGroup::BrightText, QColor( 236, 236, 236) );
    cg.setColor( QColorGroup::ButtonText, black );
    cg.setColor( QColorGroup::Base, white );
    cg.setColor( QColorGroup::Background, white );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 0, 0, 128) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setActive( cg );
    cg.setColor( QColorGroup::Foreground, black );
    cg.setColor( QColorGroup::Button, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Light, white );
    cg.setColor( QColorGroup::Midlight, QColor( 242, 242, 242) );
    cg.setColor( QColorGroup::Dark, QColor( 105, 105, 105) );
    cg.setColor( QColorGroup::Mid, QColor( 140, 140, 140) );
    cg.setColor( QColorGroup::Text, black );
    cg.setColor( QColorGroup::BrightText, QColor( 236, 236, 236) );
    cg.setColor( QColorGroup::ButtonText, black );
    cg.setColor( QColorGroup::Base, white );
    cg.setColor( QColorGroup::Background, white );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 0, 0, 128) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setInactive( cg );
    cg.setColor( QColorGroup::Foreground, QColor( 128, 128, 128) );
    cg.setColor( QColorGroup::Button, QColor( 211, 211, 211) );
    cg.setColor( QColorGroup::Light, white );
    cg.setColor( QColorGroup::Midlight, QColor( 242, 242, 242) );
    cg.setColor( QColorGroup::Dark, QColor( 105, 105, 105) );
    cg.setColor( QColorGroup::Mid, QColor( 140, 140, 140) );
    cg.setColor( QColorGroup::Text, black );
    cg.setColor( QColorGroup::BrightText, QColor( 236, 236, 236) );
    cg.setColor( QColorGroup::ButtonText, QColor( 128, 128, 128) );
    cg.setColor( QColorGroup::Base, white );
    cg.setColor( QColorGroup::Background, white );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 0, 0, 128) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setDisabled( cg );
    setPalette( pal );
    TA = new FPaletteV( this, 1, 1, 0 );
    TextLabel1 = new QLabel( this, "TextLabel1" );
    TextLabel1->setGeometry( QRect( 14, 1, 11, 14 ) );
    TextLabel1->setFont(fon);
    TextLabel1->setText( tr( "X:" ) );
    TextLabel1_2 = new QLabel(this,"TextLabel1_2");
    TextLabel1_2->setGeometry(QRect(14,14,11,14));
    TextLabel1_2->setText(tr("Y:"));
    TextLabel1_2->setFont(fon);
    TextLabel1_2_2 = new QLabel(this,"TextLabel1_2_2");
    TextLabel1_2_2->setGeometry(QRect(91,14,12,14));
    TextLabel1_2_2->setText(tr("H:"));
    TextLabel1_2_2->setFont(fon);
    TextLabel1_3 = new QLabel(this,"TextLabel1_3");
    TextLabel1_3->setGeometry(QRect(91,1,12,14));
    TextLabel1_3->setText(tr("W:"));
    TextLabel1_3->setFont(fon);
    TextLabel1_3_2 = new QLabel(this,"TextLabel1_3_2");
    TextLabel1_3_2->setGeometry(QRect(171,1,12,14));
    TextLabel1_3_2->setPixmap(QPixmap(Winkel));
    X_val = new QLineEdit(this,"X_val");
    X_val->setGeometry(QRect(26,1,62,14));
    X_val->setFrame(0);
    X_val->setFont(fon);
    X_val->setText("");
    Y_val = new QLineEdit(this,"Y_val");
    Y_val->setGeometry(QRect(26,15,62,14));
    Y_val->setFrame(0);
    Y_val->setFont(fon);
    Y_val->setText("");
    B_val = new QLineEdit(this,"B_val");
    B_val->setGeometry(QRect(106,1,62,14));
    B_val->setFrame(0);
    B_val->setFont(fon);
    B_val->setText("");
    H_val = new QLineEdit(this,"H_val");
    H_val->setGeometry(QRect(106,15,62,14));
    H_val->setFrame(0);
    H_val->setFont(fon);
    H_val->setText("");
    R_val = new QLineEdit(this,"R_val");
    R_val->setGeometry(QRect(186,1,40,14));
    R_val->setFrame(0);
    R_val->setFont(fon);
    R_val->setText("");
    L_val = new QLineEdit(this,"R_val_2");
    L_val->setGeometry(QRect(245,1,30,14));
    L_val->setFrame(0);
    L_val->setFont(fon);
    L_val->setText("");
    LineMenu = new QPopupMenu(this);
    LineMenu->insertItem(QPixmap(solidL));
    LineMenu->insertItem(QPixmap(dashL));
    LineMenu->insertItem(QPixmap(dotL));
    LineMenu->insertItem(QPixmap(dashdotL));
    LineMenu->insertItem(QPixmap(dashdotdotL));
    LineMenu->setFont(fon);
    PM2 = new IconMenuButton(this, 235, 18, LineMenu);
    PM2->hide();
    LineValueT = new QLabel(this,"sv");
    LineValueT->setGeometry(QRect(248,19,73,7));
    LineValueT->setText("");
    LineValueT->setFont(fon);
    LineValueT->hide();
    SizeMenu = new QPopupMenu(this);
    SizeMenu->insertItem("No Line");
    SizeMenu->insertItem("1 pt");
    SizeMenu->insertItem("2 pt");
    SizeMenu->insertItem("3 pt");
    SizeMenu->insertItem("4 pt");
    SizeMenu->insertItem("5 pt");
    SizeMenu->insertItem("6 pt");
    SizeMenu->insertItem("7 pt");
    SizeMenu->insertItem("8 pt");
    SizeMenu->insertItem("9 pt");
    SizeMenu->insertItem("10 pt");
    SizeMenu->setFont(fon);
    PM1 = new IconMenuButton(this, 235, 2, SizeMenu);
    PM1->hide();
    SizeValue = new QLineEdit(this,"sv");
    SizeValue->setGeometry(QRect(248,1,25,13));
    SizeValue->setText("");
    SizeValue->setFrame(0);
    SizeValue->setFont(fon);
    SizeValue->hide();
    SizeValueT = new QLabel(this,"sv");
    SizeValueT->setGeometry(QRect(273,1,25,13));
    SizeValueT->setText("");
    SizeValueT->setFont(fon);
    LSPup = new IconButton(this, 235, 2, QPixmap(Arrow_up), QPixmap(Arrow_upi));
    LSPdn = new IconButton(this, 235, 10, QPixmap(Arrow_dn), QPixmap(Arrow_dni));
    LSPup->hide();
    LSPdn->hide();
		FStyleMenu = new QPopupMenu(this);
    FontMenu = new QPopupMenu(this);
    BuildFontMenu(fo);
    PM3 = new IconMenuButton(this, 285, 2, FontMenu);
		PM3->hide();
		Fla = new QLabel(this, "fe");
    Fla->setGeometry(QRect(298, 1, 120, 13));
    Fla->setText("");
    Fla->setFont(fon);
		SizeFMenu = new QPopupMenu();
		SizeFMenu->insertItem(tr("Other..."));
		SizeFMenu->insertItem(" 7 pt");
		SizeFMenu->insertItem(" 9 pt");
		SizeFMenu->insertItem("10 pt");
		SizeFMenu->insertItem("12 pt");
		SizeFMenu->insertItem("14 pt");
		SizeFMenu->insertItem("18 pt");
		SizeFMenu->insertItem("24 pt");
		SizeFMenu->insertItem("36 pt");
		SizeFMenu->insertItem("48 pt");
		SizeFMenu->insertItem("60 pt");
		SizeFMenu->insertItem("72 pt");
    PM4 = new IconMenuButton(this, 430, 2, SizeFMenu);
    FSval = new QLineEdit(this,"FS_val");
    FSval->setGeometry(QRect(443,1,40,14));
    FSval->setFrame(0);
    FSval->setFont(fon);
    FSval->setText("");
    FSval->hide();
		PM4->hide();
    LYup = new IconButton(this, 311, 14, QPixmap(Arrow_up), QPixmap(Arrow_upi));
    LYdn = new IconButton(this, 311, 22, QPixmap(Arrow_dn), QPixmap(Arrow_dni));
    LXli = new IconButton(this, 308, 3, QPixmap(Arrow_li), QPixmap(Arrow_lii));
    LXre = new IconButton(this, 316, 3, QPixmap(Arrow_re), QPixmap(Arrow_rei));
    LXte = new QLabel(this, "te");
    LXte->setGeometry(QRect(326, 1, 20, 13));
    LXte->setText("X+:");
    LXte->setFont(fon);
    LYte = new QLabel(this, "tey");
    LYte->setGeometry(QRect(326, 15, 20, 13));
    LYte->setText("Y+:");
    LYte->setFont(fon);
    LXed = new QLineEdit(this,"led");
    LXed->setGeometry(QRect(350,1,30,13));
    LXed->setText("");
    LXed->setFrame(0);
    LXed->setFont(fon);
    LYed = new QLineEdit(this,"led");
    LYed->setGeometry(QRect(350,15,30,13));
    LYed->setText("");
    LYed->setFrame(0);
    LYed->setFont(fon);
    LScXte = new QLabel(this, "ste");
    LScXte->setGeometry(QRect(250, 1, 20, 13));
    LScXte->setText("X%:");
    LScXte->setFont(fon);
    LScYte = new QLabel(this, "ste");
    LScYte->setGeometry(QRect(250, 15, 20, 13));
    LScYte->setText("Y%:");
    LScYte->setFont(fon);
    LScXed = new QLineEdit(this,"led");
    LScXed->setGeometry(QRect(270,1,30,13));
    LScXed->setText("");
    LScXed->setFrame(0);
    LScXed->setFont(fon);
    LScYed = new QLineEdit(this,"led");
    LScYed->setGeometry(QRect(270,15,30,13));
    LScYed->setText("");
    LScYed->setFrame(0);
    LScYed->setFont(fon);
    IflipH = new IconButton(this, 234, 2, QPixmap(FlipHn), QPixmap(FlipHi));
    IflipH->setAutoRepeat(false);
    IflipV = new IconButton(this, 234, 16, QPixmap(FlipVn), QPixmap(FlipVi));
    IflipV->setAutoRepeat(false);
		HideImageWidgets();
    setTabOrder( X_val, Y_val );
    setTabOrder( Y_val, B_val );
    setTabOrder( B_val, H_val );
    setTabOrder( H_val, R_val );
    connect(LSPup, SIGNAL(clicked()), this, SLOT(AddLsp()));
    connect(LSPdn, SIGNAL(clicked()), this, SLOT(SubLsp()));
    connect(LXre, SIGNAL(clicked()), this, SLOT(AddLX()));
    connect(LXli, SIGNAL(clicked()), this, SLOT(SubLX()));
    connect(LYdn, SIGNAL(clicked()), this, SLOT(AddLY()));
    connect(LYup, SIGNAL(clicked()), this, SLOT(SubLY()));
		connect(LXed, SIGNAL(returnPressed()), this, SLOT(SetLX()));
		connect(LYed, SIGNAL(returnPressed()), this, SLOT(SetLY()));
		connect(LScXed, SIGNAL(returnPressed()), this, SLOT(SetLScX()));
		connect(LScYed, SIGNAL(returnPressed()), this, SLOT(SetLScY()));
    connect(IflipH, SIGNAL(clicked()), this, SIGNAL(FlipH()));
    connect(IflipV, SIGNAL(clicked()), this, SIGNAL(FlipV()));
    connect(SizeMenu, SIGNAL(activated(int)), this, SLOT(slotSetLineS(int)));
		connect(SizeValue, SIGNAL(returnPressed()), this, SLOT(SizeEdi()));
    connect(LineMenu, SIGNAL(activated(int)), this, SLOT(slotSetLineA(int)));
    connect(this, SIGNAL(setLineA(PenStyle)), this, SLOT(setLIvalue(PenStyle)));
    connect(FontMenu, SIGNAL(activated(int)), this, SLOT(setItemFont(int)));
    connect(SizeFMenu, SIGNAL(activated(int)), this, SLOT(setItemFSize(int)));
		connect(FSval, SIGNAL(returnPressed()), this, SLOT(SetFS()));
}
Mpalette::~Mpalette(){
}

void Mpalette::paintEvent(QPaintEvent *)
{	
	QPainter p;
	p.begin(this);
	p.setPen(black);
	p.setBrush(NoBrush);
  p.drawLine(12, 0, 12, 29);
  p.drawLine(89, 0, 89, 29);
  p.drawLine(169, 0, 169, 29);
  p.drawLine(231, 0, 231, 29);
  p.drawLine(232, 0, 232, 29);
  if (ItemArt == 2)
  	{
  	p.drawLine(248, 0, 248, 29);
  	p.drawLine(305, 0, 305, 29);
  	}
  if (ItemArt == 4)
  	{
  	p.drawLine(280, 0, 280, 29);
  	p.drawLine(280, 15, 502, 15);
  	}
  p.setPen(QPen(black, 2));
  p.drawRect(0, 0, width(), height());
	p.end();
}

void Mpalette::setXY(float x, float y)
{
	X_val->setText(QString::number(x));
	Y_val->setText(QString::number(y));
}

void Mpalette::setBH(float b, float h)
{
	B_val->setText(QString::number(b));
	H_val->setText(QString::number(h));
}

void Mpalette::setR(float r)
{
	r *= -1;
	R_val->setText(QString::number(r));
}

void Mpalette::setLIvalue(PenStyle art)
{
	switch (art)
		{
		case SolidLine:
			LineValueT->setPixmap(QPixmap(solidL));
			break;
		case DashLine:
			LineValueT->setPixmap(QPixmap(dashL));
			break;
		case DotLine:
			LineValueT->setPixmap(QPixmap(dotL));
			break;
		case DashDotLine:
			LineValueT->setPixmap(QPixmap(dashdotL));
			break;
		case DashDotDotLine:
			LineValueT->setPixmap(QPixmap(dashdotdotL));
			break;
		default:
			LineValueT->setPixmap(QPixmap());
			break;
		}
}

void Mpalette::setSvalue(int w)
{
	int a;
	SizeValue->setText(QString::number(w));
	SizeValueT->setText("pt");
	for (a = 0; a < 11; a++)
		{
		SizeMenu->setItemChecked(SizeMenu->idAt(a), false);
		}
	if ((w > -1) && (w < 11))
		{
		SizeMenu->setItemChecked(SizeMenu->idAt(w), true);
		}
}

void Mpalette::setLvalue(float scx, float scy, float x, float y)
{
	LXed->setText(QString::number(x));
	LYed->setText(QString::number(y));
	LScXed->setText(QString::number(scx*100));
	LScYed->setText(QString::number(scy*100));
}

void Mpalette::slotSetLineA(int id)
{
	int c = LineMenu->indexOf(id);
	switch (c)
		{
		case 0:
			emit setLineA(SolidLine);
			break;
		case 1:
			emit setLineA(DashLine);
			break;
		case 2:
			emit setLineA(DotLine);
			break;
		case 3:
			emit setLineA(DashDotLine);
			break;
		case 4:
			emit setLineA(DashDotDotLine);
			break;
		}
}

void Mpalette::slotSetLineS(int id)
{
	int c = SizeMenu->indexOf(id);
	setSvalue(c);
	emit setLineW(c);
}

void Mpalette::SizeEdi()
{
	int y;
	bool ok;
	y = SizeValue->text().toInt(&ok, 10);
	if (ok)
		{
		if ((ItemArt == 5) && (y == 0)) { y = 1; }
		setSvalue(y);
		emit setLineW(y);
		}
}

void Mpalette::AddLX()
{
	float x, y;
	bool ok;
	x = LXed->text().toFloat(&ok);
	if (ok)
		{
		y = LYed->text().toFloat(&ok);
		if (ok)
			{
			x += 1;
			LXed->setText(QString::number(x));
			emit setLocalXY(x, y);
			}
		}
}

void Mpalette::SubLX()
{
	float x, y;
	bool ok;
	x = LXed->text().toFloat(&ok);
	if (ok)
		{
		y = LYed->text().toFloat(&ok);
		if (ok)
			{
			x -= 1;
			LXed->setText(QString::number(x));
			emit setLocalXY(x, y);
			}
		}
}

void Mpalette::AddLY()
{
	float x, y;
	bool ok;
	y = LYed->text().toFloat(&ok);
	if (ok)
		{
		x = LXed->text().toFloat(&ok);
		if (ok)
			{
			y += 1;
			LYed->setText(QString::number(y));
			emit setLocalXY(x, y);
			}
		}
}

void Mpalette::SubLY()
{
	float x, y;
	bool ok;
	y = LYed->text().toFloat(&ok);
	if (ok)
		{
		x = LXed->text().toFloat(&ok);
		if (ok)
			{
			y -= 1;
			LYed->setText(QString::number(y));
			emit setLocalXY(x, y);
			}
		}
}

void Mpalette::AddLsp()
{
	int y;
	bool ok;
	y = L_val->text().toInt(&ok);
	if (ok)
		{
		y += 1;
		L_val->setText(QString::number(y));
		emit setLSP(y);
		}
}

void Mpalette::SubLsp()
{
	float y;
	bool ok;
	y = L_val->text().toInt(&ok);
	if (ok)
		{
		y -= 1;
		if (y < 1) { y = 1; }
		L_val->setText(QString::number(y));
		emit setLSP(y);
		}
}

void Mpalette::SetLY()
{
	float x, y;
	bool ok;
	y = LYed->text().toFloat(&ok);
	if (ok)
		{
		x = LXed->text().toFloat(&ok);
		if (ok)
			{
			emit setLocalXY(x, y);
			}
		}
}

void Mpalette::SetLX()
{
	float x, y;
	bool ok;
	x = LXed->text().toFloat(&ok);
	if (ok)
		{
		y = LYed->text().toFloat(&ok);
		if (ok)
			{
			emit setLocalXY(x, y);
			}
		}
}

void Mpalette::SetLScY()
{
	float x, y;
	bool ok;
	y = LScYed->text().toFloat(&ok);
	if (ok)
		{
		x = LScXed->text().toFloat(&ok);
		if (ok)
			{
			emit setLocalSc(x/100, y/100);
			}
		}
}

void Mpalette::SetLScX()
{
	float x, y;
	bool ok;
	x = LScXed->text().toFloat(&ok);
	if (ok)
		{
		y = LScYed->text().toFloat(&ok);
		if (ok)
			{
			emit setLocalSc(x/100, y/100);
			}
		}
}

void Mpalette::SetTextVals(int Lsp)
{
	QString cc;
	cc.setNum(Lsp);
	L_val->setText(cc);
}

void Mpalette::BuildFontMenu(SCFonts fo)
{
  Fonts = fo;
	QMap<QString,int> Fami;
	QPopupMenu *pm;
	SCFonts::Iterator it;
	FontID.clear();
	FStyleMenu->clear();
	FontMenu->clear();
	int a;
	QString b = " ";
	for (it = Fonts.begin(); it != Fonts.end(); ++it)
		{
		Fami.insert(it.key().left(it.key().find(" ")), 0);
		}
	QMap<QString,int>::Iterator it2;
	it = Fonts.begin();
	for (it2 = Fami.begin(); it2 != Fami.end(); ++it2)
		{
		pm = new QPopupMenu();
		while (it2.key() == it.key().left(it.key().find(" ")))
			{
			a = pm->insertItem(new FmItem(it.key(), Fonts[it.key()].Font));
			FontID.insert(long(a), &it.key());
			it++;
			}
  	connect(pm, SIGNAL(activated(int)), this, SLOT(setItemFont(int)));
		FStyleMenu->insertItem(it2.key(), pm);
		}
	a = FontMenu->insertItem(tr("Style"), FStyleMenu);
	FontID.insert(long(a), &b);
	a = FontMenu->insertSeparator();
	FontID.insert(long(a), &b);
}

void Mpalette::setItemFont(int id)
{
	QString nf;
	nf = *FontID[long(id)];
	emit NewFont(nf);
}

void Mpalette::AdjustFMenu(QString nf)
{
	uint a2;
	QString df;
	for (a2 = 2; a2 < FontMenu->count(); a2++)
		{
		df = *FontID[long(FontMenu->idAt(a2))];
		if (df == nf)
			{
			FontMenu->setItemChecked(FontMenu->idAt(a2), true);
			}
		else
			{
			FontMenu->setItemChecked(FontMenu->idAt(a2), false);
			}
		}
	Fla->setText(nf);
}

void Mpalette::setItemFSize(int id)
{
	int c = SizeFMenu->indexOf(id);
	bool ok = false;
	if (c > 0)
		{
		emit NewFSize(SizeFMenu->text(id).left(2).toInt());
		FSval->setText(SizeFMenu->text(id).left(2));
		}
	else
		{
    Query* dia = new Query(this, "New", 1, 0, "Size:", "Size");
    if (dia->exec())
    	{
			c = dia->Answer->text().toInt(&ok);
			if (ok)
				{
				emit NewFSize(c);
				FSval->setText(dia->Answer->text());
				}
			delete dia;
     	}
		}
}

void Mpalette::setFSizeMenu(int size)
{
	uint a;
	QString cc;
	for (a = 0; a < SizeFMenu->count(); a++)
		{
		SizeFMenu->setItemChecked(SizeFMenu->idAt(a), false);
		if (SizeFMenu->text(SizeFMenu->idAt(a)).left(2).toInt() == size)
			{
			SizeFMenu->setItemChecked(SizeFMenu->idAt(a), true);
			}
		}
	FSval->setText(cc.setNum(size));
}

void Mpalette::SetFS()
{
	int x;
	bool ok;
	x = FSval->text().toInt(&ok);
	if (ok)
		{
		emit NewFSize(x);
		setFSizeMenu(x);
		}
}

void Mpalette::NewSel(int nr)
{
	ItemArt = nr;
	switch (nr)
		{
		case -1:
			PM2->hide();
			LineValueT->hide();
			X_val->setText("");
			Y_val->setText("");
			B_val->setText("");
			H_val->setText("");
			R_val->setText("");
			L_val->setText("");
			PM1->hide();
			SizeValueT->hide();
			SizeValue->hide();
			LSPup->hide();
			LSPdn->hide();
			PM3->hide();
			Fla->hide();
    	FSval->hide();
			PM4->hide();
			HideImageWidgets();
			break;
		case 2:
			PM2->hide();
			LineValueT->hide();
			PM1->hide();
			SizeValueT->hide();
			SizeValue->hide();
			LSPup->hide();
			LSPdn->hide();
			L_val->hide();
			PM3->hide();
			Fla->hide();
    	FSval->hide();
			PM4->hide();
			ShowImageWidgets();
			break;
		case 4:
			PM2->hide();
			LineValueT->hide();
			PM1->hide();
			SizeValueT->hide();
			SizeValue->hide();
			LSPup->show();
			LSPdn->show();
			L_val->show();
			PM3->show();
			Fla->show();
    	FSval->show();
			PM4->show();
			HideImageWidgets();
			break;
		case 5:
			PM2->show();
			LineValueT->show();
			PM1->show();
			SizeValue->show();
			SizeValueT->show();
			SizeMenu->setItemEnabled(SizeMenu->idAt(0), false);
			LSPup->hide();
			LSPdn->hide();
			L_val->hide();
			PM3->hide();
			Fla->hide();
    	FSval->hide();
			PM4->hide();
			HideImageWidgets();
			break;
		default:
			PM2->show();
			LineValueT->show();
			PM1->show();
			SizeValue->show();
			SizeValueT->show();
			SizeMenu->setItemEnabled(SizeMenu->idAt(0), true);
			LSPup->hide();
			LSPdn->hide();
			L_val->hide();
			PM3->hide();
			Fla->hide();
    	FSval->hide();
			PM4->hide();
			HideImageWidgets();
			break;
		}
		repaint();
}

void Mpalette::ShowImageWidgets()
{
	LYup->show();
	LYdn->show();
	LXli->show();
	LXre->show();
	LXte->show();
	LYte->show();
  LXed->show();
  LYed->show();
  LScXte->show();
  LScYte->show();
  LScXed->show();
  LScYed->show();
  IflipH->show();
  IflipV->show();
}

void Mpalette::HideImageWidgets()
{
	LYup->hide();
	LYdn->hide();
	LXli->hide();
	LXre->hide();
	LXte->hide();
	LYte->hide();
  LXed->hide();
  LYed->hide();
  LScXte->hide();
  LScYte->hide();
  LScXed->hide();
  LScYed->hide();
  IflipH->hide();
  IflipV->hide();
}


