/***************************************************************************
                          mpalette.h  -  description
                             -------------------
    begin                : Wed Apr 18 2001
    copyright            : (C) 2001 by Franz Schmid
    email                : Franz.Schmid@altmuehlnet.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MPALETTE_H
#define MPALETTE_H

#include <qdialog.h>
#include <qvariant.h>
#include <qpixmap.h>
#include <qbuttongroup.h>
#include <qlabel.h>
#include <qtoolbutton.h>
#include <qlayout.h>
#include <qpainter.h>
#include <qpen.h>
#include <qlineedit.h>
#include <qfont.h>
#include <qpopupmenu.h>
#include <qintdict.h>
#include "fpalettev.h"
#include "iconmenubutton.h"
#include "iconbutton.h"
#include "scribusdoc.h"

/**
  *@author Franz Schmid
  */

class Mpalette : public QDialog
{
Q_OBJECT

public:
	Mpalette( QWidget* parent, SCFonts fo);
	~Mpalette();
	
    FPaletteV* TA;
    void paintEvent(QPaintEvent *);
    QLabel *TextLabel1;
    QLabel *TextLabel1_2;
    QLabel *TextLabel1_2_2;
    QLabel *TextLabel1_3;
    QLabel *TextLabel1_3_2;
    QLabel *SizeValueT;
    QLabel *LineValueT;
    QLineEdit *X_val;
    QLineEdit *Y_val;
    QLineEdit *B_val;
    QLineEdit *H_val;
    QLineEdit *R_val;
    QLineEdit *L_val;
    QLineEdit *SizeValue;
    QPopupMenu *SizeMenu;
    IconMenuButton *PM1;
    QPopupMenu *LineMenu;
    IconMenuButton *PM2;
    QPopupMenu *FStyleMenu;
    QPopupMenu *FontMenu;
    QIntDict<QString> FontID;
    SCFonts Fonts;
		ScribusDoc *doc;
    IconMenuButton *PM3;
    QLabel *Fla;
    QPopupMenu *SizeFMenu;
    IconMenuButton *PM4;
    QLineEdit *FSval;
    IconButton *LSPup;
    IconButton *LSPdn;
    IconButton *LYup;
    IconButton *LYdn;
    IconButton *LXli;
    IconButton *LXre;
    QLabel *LXte;
    QLabel *LYte;
    QLineEdit *LXed;
    QLineEdit *LYed;
    QLabel *LScXte;
    QLabel *LScYte;
    QLineEdit *LScXed;
    QLineEdit *LScYed;
    IconButton *IflipH;
    IconButton *IflipV;
    int ItemArt;
    void HideImageWidgets();
    void ShowImageWidgets();
		void BuildFontMenu(SCFonts fo);
public slots: // Public slots
  /** Setzt die X und Y Werte */
  void setXY(float x, float y);
  /** Setzt die B und H Werte */
  void setBH(float b, float h);
  /** Setzt den R Wert */
  void setR(float r);
  /** ndert das Aussehen anhand der neuen Auswahl */
  void NewSel(int nr);
  /** Setzt den Wert des Size-Menus */
  void setSvalue(int w);
  /** Setzt die Linienstrke */
  void slotSetLineS(int id);
  /** Setzt die Linienstrke per Eingabe */
  void SizeEdi();
  /** Setzt die Lokalen Bilddaten */
  void setLvalue(float scx, float scy, float x, float y);
  /** Setzt die Linienart */
  void setLIvalue(PenStyle art);
  /** Setzt die Linienart */
  void slotSetLineA(int id);
  /** Erhht LocalX um 1 */
  void AddLX();
  /** Vermindert LocalX um 1 */
  void SubLX();
  /** Erhht LocalY um 1 */
  void AddLY();
  /** Vermindert LocalY um 1 */
  void SubLY();
  /** Setzt LocalX */
  void SetLX();
  /** Setzt LocalY */
  void SetLY();
  /** Setzt LocalScX */
  void SetLScX();
  /** Setzt LocalY */
  void SetLScY();
  /** setzt die Textattribute */
  void SetTextVals(int Lsp);
  /** erhht den Zeilenabstand */
  void AddLsp();
  /** verringert den Zeilenabstand */
  void SubLsp();
	void setItemFont(int id);
	void AdjustFMenu(QString nf);
	void setFSizeMenu(int size);
	void setItemFSize(int id);
	void SetFS();
signals: // Signals
  /** Setzt die Linienbreite */
  void setLineW(int);
  /** Setzt die Linienart */
  void setLineA(PenStyle);
  /** Setzt das lokale Scaling */
  void setLocalSc(float, float);
  /** Setzt die lokalen Koordinaten */
  void setLocalXY(float, float);
  /** Spiegelt das Bild horizontal */
  void FlipH();
  /** Spiegelt das Bild vertikal */
  void FlipV();
  /** Setzt den Zeilenabstand */
  void setLSP(int);
  /** Setzt den Zeichensatz */
  void NewFont(QString);
  /** Setzt die Zeichengre */
  void NewFSize(int);
};

#endif
