/***************************************************************************
                          pageitem.h  -  description
                             -------------------
    begin                : Sat Apr 7 2001
    copyright            : (C) 2001 by Franz Schmid
    email                : Franz.Schmid@altmuehlnet.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PAGEITEM_H
#define PAGEITEM_H

#include <qobject.h>
#include <qwidget.h>
#include <qpointarray.h>
#include <qlist.h>
#include <qimage.h>
#include <qfont.h>
#include "scribusdoc.h"
/**
  *@author Franz Schmid
  */
							
class PageItem : public QObject  {

public: 
	PageItem(QWidget* pa, int art, float x, float y, float w, float h, int w2, QString fill, QString outline, ScribusDoc *doc);
	~PageItem();
  /** Zeichnet das Item */
  void paintObj(QRect e=QRect());
  void CopyIt(struct CLBuf *Buffer);
  /** X-Position auf der Seite */
  float Xpos;
  /** Y-Position auf der Seite */
  float Ypos;
  /** Breite des Elements */
  float Width;
  /** Hhe des Elements */
  float Height;
  /** Art des Items */
  int PType;
  /** Winkel um den das Item gedreht wird */
  float Rot;
  /** Enthlt das bergeordnete Objekt */
  QWidget *Parent;
  /** Enthlt das Dokument */
  ScribusDoc *Doc;
  /** Fllfarbe */
  QString Pcolor;
  /** Abstufung fr Fllfarbe */
  int Shade;
  /** Zeichenfarbe fr Elemente */
  QString Pcolor2;
  /** Abstufung fr Zeichenfarbe */
  int Shade2;
  /** Strichstrke */
  int Pwidth;
  /** Linienart */
  PenStyle PLineArt;
  /** Fllung Ja/Nein */
  bool Transparent;
  /** Element selektiert Ja/Nein */
  bool Select;
  /** Definiert die Clipping-Region des Elements; */
  QPointArray Clip;
  /** Interne Item-Nummer */
  uint ItemNr;
  /** Hat Element Rahmen? */
  bool Frame;
  /** Seite zu der das Element gehrt */
  Page *OwnPage;
  /** Darzustellendes Bild */
  QImage pixm;
  /** Dateiname des Bildes */
  QString Pfile;
  /** Darstellungsart Bild/Titel */
  bool PicArt;
  /** Bild verfgbar */
  bool PicAvail;
  /** Lokales Scaling x*/
  float LocalScX;
  /** Lokales Scaling y*/
  float LocalScY;
  /** Lokales X */
  float LocalX;
  /** Lokales Y */
  float LocalY;
  /** Anzahl horizontaler Spiegelungen */
  int flippedH;
  /** Anzahl vertikaler Spiegelungen */
  int flippedV;
  /** BoundigBox-X */
  float BBoxX;
  /** BoundingBox-H */
  float BBoxH;
  /** Extra Abstand vom Rand */
  float Extra;
  /** Linespacing */
  float LineSp;
  /** Zeichen X-Position */
  float CurX;
  /** Zeichen Y-Position */
  float CurY;
  /** Cursorposition */
  int CPos;
  /** Text des Elements */
  QList<Pti> Ptext;
  /** Flag ob Element gedruckt wird */
  bool isPrintable;
  /** Flag fr PDF-Bookmark */
  bool isBookmark;
  /** Flag fr neuzeichnen im EditMode */
  bool Dirty;
  /** Item Font */
  QString IFont;
  /** Item Fontgre */
  int ISize;
  /** Flag fr Auswahl */
  bool HasSel;
};

#endif
