#include "prefs.h"
#include <qfont.h>
#include <qcolordialog.h>
#include <qcolor.h>

Preferences::Preferences( QWidget* parent,
													SCFonts fonts,
													QString Dfon,
													int DSiz,
													int Wv,
													int Dmi,
													int Dma,
													QColor DmiC,
													QColor DmaC,
													int GUI)
    : QDialog( parent, "pref", true, 0 )
{
    fon = fonts;
    DefFont = Dfon;
    DefSize = DSiz;
    resize( 360, 285 );
    setMinimumSize( QSize( 360, 285 ) );
    setMaximumSize( QSize( 360, 285 ) );
    setCaption( tr( "Preferences" ) );

    QWidget* privateLayoutWidget = new QWidget( this, "Layout3" );
    privateLayoutWidget->setGeometry( QRect( 27, 245, 294, 35 ) ); 
    Layout3 = new QHBoxLayout( privateLayoutWidget ); 
    Layout3->setSpacing( 6 );
    Layout3->setMargin( 0 );

    buttonOK = new QPushButton( privateLayoutWidget, "buttonOK" );
    buttonOK->setText( tr( "OK" ) );
    buttonOK->setDefault( TRUE );
    Layout3->addWidget( buttonOK );
    QSpacerItem* spacer = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    Layout3->addItem( spacer );

    buttonCancel = new QPushButton( privateLayoutWidget, "buttonCancel" );
    buttonCancel->setText( tr( "Cancel" ) );
    Layout3->addWidget( buttonCancel );

    TabWidget3 = new QTabWidget( this, "TabWidget3" );
    TabWidget3->setGeometry( QRect( 12, 9, 330, 230 ) ); 

    tab = new QWidget( TabWidget3, "tab" );

    Mouse = new QGroupBox( tab, "Mouse" );
    Mouse->setGeometry( QRect( 8, 145, 301, 51 ) ); 
    Mouse->setTitle( tr( "Mouse-Wheel" ) );

    TextLabel1_2 = new QLabel( Mouse, "TextLabel1_2" );
    TextLabel1_2->setGeometry( QRect( 10, 20, 110, 21 ) ); 
    TextLabel1_2->setText( tr( "Scroll-Distance" ) );

    SpinBox3 = new QSpinBox( Mouse, "SpinBox3" );
    SpinBox3->setGeometry( QRect( 130, 20, 50, 21 ) ); 
    SpinBox3->setMaxValue( 1000 );
    SpinBox3->setMinValue( 0 );
    SpinBox3->setLineStep( 10 );
    SpinBox3->setValue( Wv );

    ButtonGroup1 = new QButtonGroup( tab, "ButtonGroup1" );
    ButtonGroup1->setGeometry( QRect( 10, 10, 301, 127 ) ); 
    ButtonGroup1->setTitle( tr( "GUI-Style" ) );

    RadioButton1 = new QRadioButton( ButtonGroup1, "RadioButton1" );
    RadioButton1->setGeometry( QRect( 10, 20, 121, 25 ) ); 
    RadioButton1->setText( tr( "Platinum-Style" ) );

    RadioButton2 = new QRadioButton( ButtonGroup1, "RadioButton2" );
    RadioButton2->setGeometry( QRect( 10, 50, 114, 25 ) ); 
    RadioButton2->setText( tr( "Windows-Style" ) );

    RadioButton3 = new QRadioButton( ButtonGroup1, "RadioButton3" );
    RadioButton3->setGeometry( QRect( 10, 80, 108, 25 ) ); 
    RadioButton3->setText( tr( "Motif-Style" ) );

    RadioButton4 = new QRadioButton( ButtonGroup1, "RadioButton4" );
    RadioButton4->setGeometry( QRect( 150, 20, 115, 25 ) ); 
    RadioButton4->setText( tr( "CDE-Style" ) );

    RadioButton5 = new QRadioButton( ButtonGroup1, "RadioButton5" );
    RadioButton5->setGeometry( QRect( 150, 50, 131, 25 ) ); 
    RadioButton5->setText( tr( "Motif-Plus-Style" ) );
    switch (GUI)
    	{
    	case 1:
    		RadioButton1->setChecked(true);
    		break;
    	case 2:
    		RadioButton2->setChecked(true);
    		break;
    	case 3:
    		RadioButton3->setChecked(true);
    		break;
    	case 4:
    		RadioButton4->setChecked(true);
    		break;
    	case 5:
    		RadioButton5->setChecked(true);
    		break;
    	}
    TabWidget3->insertTab( tab, tr( "General" ) );

    tab_2 = new QWidget( TabWidget3, "tab_2" );

    GroupBox1 = new QGroupBox( tab_2, "GroupBox1" );
    GroupBox1->setGeometry( QRect( 10, 10, 300, 85 ) ); 
    GroupBox1->setTitle( tr( "Grid Layout" ) );

    TextLabel1 = new QLabel( GroupBox1, "TextLabel1" );
    TextLabel1->setGeometry( QRect( 10, 20, 150, 20 ) ); 
    TextLabel1->setText( tr( "Minor Grid Spacing:" ) );

    TextLabel2 = new QLabel( GroupBox1, "TextLabel2" );
    TextLabel2->setGeometry( QRect( 11, 50, 150, 20 ) ); 
    TextLabel2->setText( tr( "Major Grid Spacing:" ) );

    SpinBox1 = new QSpinBox( GroupBox1, "SpinBox1" );
    SpinBox1->setGeometry( QRect( 160, 20, 60, 20 ) ); 
    SpinBox1->setMaxValue( 1000 );
    SpinBox1->setMinValue( 1 );
    SpinBox1->setLineStep( 1 );
    SpinBox1->setValue( Dmi );

    SpinBox2 = new QSpinBox( GroupBox1, "SpinBox2" );
    SpinBox2->setGeometry( QRect( 160, 50, 60, 20 ) ); 
    SpinBox2->setMaxValue( 1000 );
    SpinBox2->setMinValue( 10 );
    SpinBox2->setLineStep( 10 );
    SpinBox2->setValue( Dma );

    GroupBox2 = new QGroupBox( tab_2, "GroupBox2" );
    GroupBox2->setGeometry( QRect( 9, 102, 300, 85 ) ); 
    GroupBox2->setTitle( tr( "Grid Colors:" ) );

    TextLabel3 = new QLabel( GroupBox2, "TextLabel3" );
    TextLabel3->setGeometry( QRect( 10, 20, 150, 20 ) ); 
    TextLabel3->setText( tr( "Minor Grid Color:" ) );

    TextLabel4 = new QLabel( GroupBox2, "TextLabel4" );
    TextLabel4->setGeometry( QRect( 10, 50, 150, 20 ) ); 
    TextLabel4->setText( tr( "Major Grid Color:" ) );

    minColor = new QPushButton( GroupBox2, "minColor" );
    minColor->setGeometry( QRect( 150, 20, 100, 20 ) ); 
    minColor->setText( tr( "" ) );
    minColor->setAutoDefault( FALSE );
    QPixmap pm = QPixmap(100, 20);
    pm.fill(DmiC);
    minColor->setPixmap(pm);
    minColor->setBackgroundColor(DmiC);

    MaxColor = new QPushButton( GroupBox2, "MaxColor" );
    MaxColor->setGeometry( QRect( 150, 50, 100, 20 ) ); 
    MaxColor->setText( tr( "" ) );
    MaxColor->setAutoDefault( FALSE );
    QPixmap pm1 = QPixmap(100, 20);
    pm1.fill(DmaC);
    MaxColor->setPixmap(pm1);
    MaxColor->setBackgroundColor(DmaC);
    TabWidget3->insertTab( tab_2, tr( "Guides" ) );

    tab_3 = new QWidget( TabWidget3, "tab_3" );

    TextLabel2_2 = new QLabel( tab_3, "TextLabel2_2" );
    TextLabel2_2->setGeometry( QRect( 20, 65, 115, 23 ) );
    TextLabel2_2->setText( tr( "Default Size:" ) );

    TextLabel1_3 = new QLabel( tab_3, "TextLabel1_3" );
    TextLabel1_3->setGeometry( QRect( 20, 16, 115, 29 ) );
    TextLabel1_3->setText( tr( "Default Font:" ) );

    FontCombo = new QComboBox( true, tab_3, "FontCombo" );
    FontCombo->setGeometry( QRect( 120, 17, 170, 26 ) );
    FontCombo->setEditable(false);
    SCFonts::Iterator it;
    for (it = fon.begin(); it != fon.end(); ++it)
    	{
    	FontCombo->insertItem(it.key());
    	if (it.key() == DefFont)
    		{
    		FontCombo->setCurrentItem(FontCombo->count()-1);
    		}
    	}

    SizeCombo = new QComboBox( true, tab_3, "SizeCombo" );
    SizeCombo->setGeometry( QRect( 120, 66, 70, 26 ) );
    SizeCombo->setEditable(false);
		SizeCombo->insertItem(" 7 pt");
		SizeCombo->insertItem(" 9 pt");
		SizeCombo->insertItem("10 pt");
		SizeCombo->insertItem("12 pt");
		SizeCombo->insertItem("14 pt");
		SizeCombo->insertItem("18 pt");
		SizeCombo->insertItem("24 pt");
		SizeCombo->insertItem("36 pt");
		SizeCombo->insertItem("48 pt");
		SizeCombo->insertItem("60 pt");
		SizeCombo->insertItem("72 pt");
		int a;
		for (a = 0; a < SizeCombo->count(); a++)
			{
			if (SizeCombo->text(a).left(2).toInt() == DefSize)
				{
				SizeCombo->setCurrentItem(a);
				}
			}

    TextLabel1_4 = new QLabel( tab_3, "TextLabel1_4" );
    TextLabel1_4->setGeometry( QRect( 20, 112, 288, 71 ) ); 
    TextLabel1_4->setText( tr( "Sample Text" ) );
    TextLabel1_4->setAlignment( int( QLabel::AlignTop | QLabel::AlignLeft ) );
    SetSample();
    TabWidget3->insertTab( tab_3, tr( "Fonts" ) );

    // signals and slots connections
    connect( minColor, SIGNAL( clicked() ), this, SLOT( changeMicolor() ) );
    connect( MaxColor, SIGNAL( clicked() ), this, SLOT( changeMaColor() ) );
    connect( buttonOK, SIGNAL( clicked() ), this, SLOT( accept() ) );
    connect( buttonCancel, SIGNAL( clicked() ), this, SLOT( reject() ) );
    connect(FontCombo, SIGNAL(activated(int)), this, SLOT(SetSample()));
    connect(SizeCombo, SIGNAL(activated(int)), this, SLOT(SetSample()));
}

/*  
 *  Destroys the object and frees any allocated resources
 */
Preferences::~Preferences()
{
    // no need to delete child widgets, Qt does it all for us
}

void Preferences::SetSample()
{
	QFont fo;
	fo = fon[FontCombo->currentText()].Font;
	fo.setPointSize(SizeCombo->currentText().left(2).toInt());
	TextLabel1_4->setFont(fo);
}

void Preferences::changeMaColor()
{
	QColor neu = QColor();
	neu = QColorDialog::getColor(MaxColor->backgroundColor(), this);
	if (neu.isValid())
		{
    QPixmap pm = QPixmap(100, 20);
    pm.fill(neu);
    MaxColor->setPixmap(pm);
   	MaxColor->setBackgroundColor(neu);	
		}
}

void Preferences::changeMicolor()
{
	QColor neu = QColor();
	neu = QColorDialog::getColor(minColor->backgroundColor(), this);
	if (neu.isValid())
		{
    QPixmap pm = QPixmap(100, 20);
    pm.fill(neu);
    minColor->setPixmap(pm);
   	minColor->setBackgroundColor(neu);	
		}
}

