/***************************************************************************
                          pslib.cpp  -  description
                             -------------------
    begin                : Sat May 26 2001
    copyright            : (C) 2001 by Franz Schmid
    email                : Franz.Schmid@altmuehlnet.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <qfileinfo.h>
#include <qfile.h>
#include <qtextstream.h>
#include <stdlib.h>
#include "pslib.h"

PSLib::PSLib(bool psart, SCFonts AllFonts, QMap<QString,QFont> DocFonts)
{
	QString tmp;
	Seiten = 0;
	Seite = "";
	Dokument = "";
	User = "";
	Creator = "PSlib-0.1";
	Titel = "";
	FillColor = "0.0 0.0 0.0";
	StrokeColor = "0.0 0.0 0.0";
  if (psart)
  	{
  	Header = "%!PS-Adobe-3.0\n";
  	}
  else
  	{
  	Header = "%!PS-Adobe-3.0 EPSF-3.0\n";
  	}
	BBox = "";
	BBoxH = "";
	Art = psart;
	isPDF = false;
	UsedFonts.clear();
	Fonts = "";
	FontDesc = "";
	QMap<QString,QFont>::Iterator it;
	int a = 0;
	for (it = DocFonts.begin(); it != DocFonts.end(); ++it)
		{
		UsedFonts.insert(it.key(), "/Fo"+IToStr(a));
		Fonts += "/"+AllFonts[it.key()].RealName+" /Fo"+IToStr(a)+" cf ef\n";
		if (AllFonts[it.key()].EmbedPS)
			{
			QFileInfo fi = QFileInfo(AllFonts[it.key()].Datei);
			if (fi.extension(false).lower() == "pfa")
				{
				QFile f(AllFonts[it.key()].Datei);
				if (f.open(IO_ReadOnly))
					{
					QTextStream t(&f);
					tmp = t.read();
					f.close();
					}
				else
					{
					tmp = "";
					}
				}
			if (fi.extension(false).lower() == "pfb")
				{
				system("pfb2pfa " + AllFonts[it.key()].Datei + " /tmp/ff.pfa");
				QFile f("/tmp/ff.pfa");
				if (f.open(IO_ReadOnly))
					{
					QTextStream t(&f);
					tmp = t.read();
					f.close();
					}
				else
					{
					tmp = "";
					}
				system("rm -f /tmp/ff.pfa");
				}
			if (tmp != "")
				{
				FontDesc += "%%BeginFont: " + AllFonts[it.key()].RealName + "\n";
				FontDesc += tmp + "\n%%EndFont\n";
				}
			}
		a++;
		}
	Prolog = "%%BeginProlog\n";
	Prolog += "/Scribusdict 100 dict def\n";
	Prolog += "Scribusdict begin\n";
	Prolog += "/rgb {setrgbcolor} bind def\n";
	Prolog += "/m {moveto} bind def\n";
	Prolog += "/li {lineto} bind def\n";
	Prolog += "/cl {closepath} bind def\n";
	Prolog += "/gs {gsave} bind def\n";
	Prolog += "/gr {grestore} bind def\n";
	Prolog += "/tr {translate} bind def\n";
	Prolog += "/ro {rotate} bind def\n";
	Prolog += "/sh {show} bind def\n";
	Prolog += "/shm {setrgbcolor moveto show} bind def\n";
	Prolog += "/sc {scale} bind def\n";
	Prolog += "/se {selectfont} bind def\n";
	Prolog += "/sw {setlinewidth} bind def\n";
	Prolog += "/f {findfont} bind def\n";
	Prolog += "/mf {makefont} bind def\n";
	Prolog += "/ss {scalefont setfont} bind def\n";
	Prolog += "/ci {newpath 0 360 arc} bind def\n";
	Prolog += "/fi {fill} bind def\n";
	Prolog += "/st {stroke} bind def\n";
	Prolog += "/cf [\n";
	Prolog += "    16#80 /euro\n";
	Prolog += "    16#82 /quotesinglbase\n";
	Prolog += "    16#83 /florin\n";
	Prolog += "    16#84 /quotedblbase\n";
	Prolog += "    16#85 /ellipsis\n";
	Prolog += "    16#86 /dagger\n";
	Prolog += "    16#87 /daggerdbl\n";
	Prolog += "    16#88 /circumflex\n";
	Prolog += "    16#89 /perthousand\n";
	Prolog += "    16#8a /Scaron\n";
	Prolog += "    16#8b /guilsinglleft\n";
	Prolog += "    16#8c /OE\n";
	Prolog += "    16#8e /zcaron\n";
	Prolog += "    16#91 /quoteleft\n";
	Prolog += "    16#92 /quoteright\n";
	Prolog += "    16#93 /quotedblleft\n";
	Prolog += "    16#94 /quotedblright\n";
	Prolog += "    16#95 /bullet\n";
	Prolog += "    16#96 /endash\n";
	Prolog += "    16#97 /emdash\n";
	Prolog += "    16#98 /tilde\n";
	Prolog += "    16#99 /trademark\n";
	Prolog += "    16#9a /scaron\n";
	Prolog += "    16#9b /guilsinglright\n";
	Prolog += "    16#9c /oe\n";
	Prolog += "    16#9e /zcaron\n";
	Prolog += "    16#9f /Ydieresis\n";
	Prolog += "] def\n";
	Prolog += "/ski /ISOLatin1Encoding where{pop true}{false}ifelse def\n";
	Prolog += "/reencodesmalldict 12 dict def\n";
	Prolog += "/ef {\n";
	Prolog += "    reencodesmalldict begin\n";
	Prolog += "    /newcodesandnames exch def\n";
	Prolog += "    /newfontname exch def\n";
	Prolog += "    /basefontname exch def\n";
	Prolog += "    /basefontdict basefontname findfont def\n";
	Prolog += "    /newfont basefontdict maxlength dict def\n";
	Prolog += "    basefontdict\n";
	Prolog += "    {\n";
	Prolog += "        exch dup /FID ne\n";
	Prolog += "        {\n";
	Prolog += "            dup /Encoding eq\n";
	Prolog += "            {\n";
	Prolog += "                ski\n";
	Prolog += "                {\n";
	Prolog += "                    exch pop\n";
	Prolog += "                    ISOLatin1Encoding dup length array copy\n";
	Prolog += "                }{\n";
	Prolog += "                exch dup length array copy\n";
	Prolog += "            }\n";
	Prolog += "            ifelse\n";
	Prolog += "            newfont 3 1 roll put\n";
	Prolog += "            }{\n";
	Prolog += "                exch newfont 3 1 roll put\n";
	Prolog += "            }\n";
	Prolog += "            ifelse\n";
	Prolog += "        }{\n";
	Prolog += "        pop pop\n";
	Prolog += "    }\n";
	Prolog += "    ifelse\n";
	Prolog += "    } forall\n";
	Prolog += "    newfont /FontName newfontname put\n";
	Prolog += "    newcodesandnames aload pop\n";
	Prolog += "    newcodesandnames length 2 idiv\n";
	Prolog += "    {\n";
	Prolog += "        newfont /Encoding get 3 1 roll put\n";
	Prolog += "    } repeat\n";
	Prolog += "    newfontname newfont definefont pop\n";
	Prolog += "    end\n";
	Prolog += "    } def\n";
	Prolog += "/bEPS { %def\n";
	Prolog += "    /b4_Inc_state save def\n";
	Prolog += "    /dict_count countdictstack def\n";
	Prolog += "    /op_count count 1 sub def\n";
	Prolog += "    userdict begin\n";
	Prolog += "    /showpage { } def\n";
	Prolog += "    0 setgray 0 setlinecap\n";
	Prolog += "    1 setlinewidth 0 setlinejoin\n";
	Prolog += "    10 setmiterlimit [ ] 0 setdash newpath\n";
	Prolog += "    /languagelevel where\n";
	Prolog += "    {pop languagelevel\n";
	Prolog += "    1 ne\n";
	Prolog += "    {false setstrokeadjust false setoverprint\n";
	Prolog += "    } if } if } bind def\n";
	Prolog += "/eEPS { %def count op_count sub {pop} repeat\n";
	Prolog += "    countdictstack dict_count sub {end} repeat\n";
	Prolog += "    b4_Inc_state restore } bind def\n";
	Prolog += "    end\n";
	Prolog += "%%EndProlog\n";
}
PSLib::~PSLib()
{
}

void PSLib::PutSeite(QString c)
{
	Seite += c;
}

void PSLib::PutDoc(QString c)
{
	Dokument += c;
}

QString PSLib::ToStr(float c)
{
	QString cc;
	return cc.setNum(c);
}

QString PSLib::IToStr(int c)
{
	QString cc;
	return cc.setNum(c);
}

void PSLib::PS_set_Info(QString art, QString was)
{
	if (art == "Author")
		User = was;
	if (art == "Creator")
		Creator = was;
	if (art == "Title")
		Titel = was;
}

void PSLib::PS_begin_page(float breite, float hoehe)
{
	BBox = "%%BoundingBox: 0 0 " + IToStr(qRound(breite)) + " " + IToStr(qRound(hoehe)) + "\n";
	BBoxH = "%%HiResBoundingBox: 0 0 " + ToStr(breite) + " " + ToStr(hoehe) + "\n";
	Seiten++;
	PutSeite("%%Page: " + IToStr(Seiten) + " " + IToStr(Seiten) + "\nsave\n");
}

void PSLib::PS_end_page()
{
	PutSeite("%%PageTrailer\nrestore\nshowpage\n");
}

void PSLib::PS_rect(float x, float y, float b, float h)
{
	PutSeite(ToStr(x) + " " + ToStr(y) + " m\n");
	PutSeite(ToStr(x) + " " + ToStr(y+h) + " li\n");
	PutSeite(ToStr(x+b) + " " + ToStr(y+h) + " li\n");
	PutSeite(ToStr(x+b) + " " + ToStr(y) + " li\n");
	PutSeite("cl\n");
}

void PSLib::PS_circle(float x, float y, float r)
{
	PutSeite(ToStr(x) + " " + ToStr(y) + " " + ToStr(r) + " ci\n");
}

void PSLib::PS_moveto(float x, float y)
{
	PutSeite(ToStr(x) + " " + ToStr(y) + " m\n");
}

void PSLib::PS_lineto(float x, float y)
{
	PutSeite(ToStr(x) + " " + ToStr(y) + " li\n");
}

void PSLib::PS_closepath()
{
	PutSeite("cl\n");
}

void PSLib::PS_translate(float x, float y)
{
	PutSeite(ToStr(x) + " " + ToStr(y) + " tr\n");
}

void PSLib::PS_scale(float x, float y)
{
	PutSeite(ToStr(x) + " " + ToStr(y) + " sc\n");
}

void PSLib::PS_rotate(float x)
{
	PutSeite(ToStr(x) + " ro\n");
}

void PSLib::PS_clip()
{
	PutSeite("clip newpath\n");
}

void PSLib::PS_save()
{
	PutSeite("gs\n");
}

void PSLib::PS_restore()
{
	PutSeite("gr\n");
}

void PSLib::PS_setrgbcolor_fill(float r, float g, float b)
{
	FillColor = ToStr(r) + " " + ToStr(g) + " " + ToStr(b);
}

void PSLib::PS_setrgbcolor_stroke(float r, float g, float b)
{
	StrokeColor = ToStr(r) + " " + ToStr(g) + " " + ToStr(b);
}

void PSLib::PS_setlinewidth(int w)
{
	PutSeite(IToStr(w) + " sw\n");
	LineW = w;
}

void PSLib::PS_setdash(Qt::PenStyle st)
{
	QString Dt = IToStr(3*LineW);
	QString Da = IToStr(6*LineW);
	switch (st)
		{
		case Qt::SolidLine:
			PutSeite("[] 0 setdash\n");
			break;
		case Qt::DashLine:
			PutSeite("["+Da+"] 0 setdash\n");
			break;
		case Qt::DotLine:
			PutSeite("["+Dt+"] 0 setdash\n");
			break;
		case Qt::DashDotLine:
			PutSeite("["+Da+" "+Dt+" "+Dt+" "+Dt+"] 0 setdash\n");
			break;
		case Qt::DashDotDotLine:
			PutSeite("["+Da+" "+Dt+" "+Dt+" "+Dt+" "+Dt+" "+Dt+"] 0 setdash\n");
			break;
		default:
			PutSeite("[] 0 setdash\n");
			break;
		}
}

void PSLib::PS_selectfont(QString f, int s)
{
	PutSeite(UsedFonts[f] + " " + IToStr(s) + " se\n");
}

void PSLib::PS_fill()
{
	PutSeite(FillColor + " rgb fi\n");
}

void PSLib::PS_stroke()
{
	PutSeite(StrokeColor + " rgb st\n");
}

void PSLib::PS_fill_stroke()
{
	PS_save();
	PS_fill();
	PS_restore();
	PS_stroke();
}

void PSLib::PS_show_xy(int ch, float x, float y)
{
	QString cc;
	PutSeite("(\\"+cc.setNum(ch, 8)+") "+ToStr(x)+" "+ToStr(y)+" "+StrokeColor+" shm\n");
}

void PSLib::PS_image(float x, float y, QString fn, float scalex, float scaley)
{
	QString tmp;
	QFileInfo fi = QFileInfo(fn);
	QString ext = fi.extension(false).lower();
	if (ext == "eps")
		{
		QFile f(fn);
		if (f.open(IO_ReadOnly))
			{
			QTextStream ts(&f);
			tmp = ts.read();	
			f.close();
      PutSeite("bEPS\n");
      PutSeite(ToStr(x) + " " + ToStr(y) + " tr\n");
      PutSeite(ToStr(scalex) + " " + ToStr(scaley) + " sc\n");
      PutSeite("%%BeginDocument: " + fi.fileName() + "\n");
      PutSeite(tmp);
      PutSeite("%%EndDocument\n");
      PutSeite("eEPS\n");
			}
		}
	else
		{
		FILE *fp = popen("convert "+fn+" eps:-", "r");
		if (fp != NULL)
			{
			QTextStream ts3(fp, IO_ReadOnly);
			tmp = ts3.read();
    	PutSeite("bEPS\n");
    	PutSeite(ToStr(x) + " " + ToStr(y) + " tr\n");
    	PutSeite(ToStr(scalex) + " " + ToStr(scaley) + " sc\n");
    	PutSeite("%%BeginDocument: " + fi.fileName() + "\n");
    	PutSeite(tmp);
    	PutSeite("%%EndDocument\n");
    	PutSeite("eEPS\n");
    	pclose(fp);
    	}
		}
}

void PSLib::PDF_Bookmark(QString text, uint Seite)
{
	PutSeite("[/Title ("+text+") /Page "+IToStr(Seite)+" /View [/Fit]\n");
	PutSeite("/OUT pdfmark\n");
	isPDF = true;
}


QString PSLib::PS_close()
{
	Dokument = Header;
	PutDoc("%%For: " + User + "\n");
	PutDoc("%%Title: " + Titel + "\n");
	PutDoc("%%Creator: " + Creator + "\n");
	PutDoc("%%Pages: " + IToStr(Seiten) + "\n");
	if (!Art)
		{
		PutDoc(BBox);
		PutDoc(BBoxH);
		}
	PutDoc("%%LanguageLevel: 2\n");
	PutDoc("%%EndComments\n");
	PutDoc(Prolog);
	PutDoc("%%BeginSetup\n");
	if (isPDF)
		{
		PutDoc("/pdfmark where {pop} {userdict /pdfmark /cleartomark load put} ifelse\n");
		}
	if (FontDesc != "")
		{
		PutDoc(FontDesc);
		}
	PutDoc("Scribusdict begin\n");
	PutDoc(Fonts);
	PutDoc("%%EndSetup\n");
	PutDoc(Seite);
	PutDoc("%%Trailer\n");
	PutDoc("end\n");
	PutDoc("%%EOF\n");
	return Dokument;
}
