/***************************************************************************
                          pslib.h  -  description
                             -------------------
    begin                : Sat May 26 2001
    copyright            : (C) 2001 by Franz Schmid
    email                : Franz.Schmid@altmuehlnet.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PSLIB_H
#define PSLIB_H
#include <qstring.h>
#include <qpen.h>
#include "scribusdoc.h"

/**
  *@author Franz Schmid
  * Diese Klasse erzeugt Postscript-Dateien
  */

class PSLib {
public: 
	PSLib(bool psart, SCFonts AllFonts, QMap<QString,QFont> DocFonts);
	~PSLib();
	void PS_set_Info(QString art, QString was);
	void PS_begin_page(float breite, float hoehe);
	void PS_end_page();
	void PS_rect(float x, float y, float b, float h);
	void PS_circle(float x, float y, float r);
	void PS_moveto(float x, float y);
	void PS_lineto(float x, float y);
	void PS_closepath();
	void PS_translate(float x, float y);
	void PS_scale(float x, float y);
	void PS_rotate(float x);
	void PS_clip();
	void PS_save();
	void PS_restore();
	void PS_setrgbcolor_fill(float r, float g, float b);
	void PS_setrgbcolor_stroke(float r, float g, float b);
	void PS_setlinewidth(int w);
	void PS_setdash(Qt::PenStyle st);
	void PS_selectfont(QString f, int s);
	void PS_fill();
	void PS_stroke();
	void PS_fill_stroke();
	void PS_show_xy(int ch, float x, float y);
	void PS_image(float x, float y, QString fn, float scalex, float scaley);
	void PDF_Bookmark(QString text, uint Seite);
	QString PS_close();
private:
	void PutSeite(QString c);
	void PutDoc(QString c);
	QString ToStr(float c);
	QString IToStr(int c);
	bool Art;
	QString Prolog;
	QString Header;
	QString Creator;
	QString User;
	QString Titel;
	QString BBox;
	QString BBoxH;
	int Seiten;
	QString Dokument;
	QString Seite;
	QString FillColor;
	QString StrokeColor;
	int LineW;
	QString Fonts;
	QString FontDesc;
	QMap<QString, QString> UsedFonts;
	SCFonts FontDef;
	bool isPDF;
};

#endif
