#include "reformdoc.h"

ReformDoc::ReformDoc( QWidget* parent, int t, int l, int r, int b, bool fp)
    : QDialog( parent, "r", true, 0 )
{
    resize( 295, 145 ); 
    setMaximumSize( QSize( 295, 145 ) );
    setCaption( tr( "Document Setup" ) );

    GroupBox7 = new QGroupBox( this, "GroupBox7" );
    GroupBox7->setGeometry( QRect( 7, 7, 278, 91 ) ); 
    GroupBox7->setTitle( tr( "Margin Guides" ) );

    TextLabel5 = new QLabel( GroupBox7, "TextLabel5" );
    TextLabel5->setGeometry( QRect( 8, 15, 52, 20 ) ); 
    TextLabel5->setText( tr( "Top:" ) );

    TextLabel7 = new QLabel( GroupBox7, "TextLabel7" );
    TextLabel7->setGeometry( QRect( 8, 39, 50, 20 ) ); 
    TextLabel7->setText( tr( "Bottom:" ) );

    TopR = new QSpinBox( GroupBox7, "TopR" );
    TopR->setGeometry( QRect( 63, 15, 70, 20 ) ); 
    TopR->setSuffix( tr( " mm" ) );
    TopR->setMaxValue( 1000 );
    TopR->setValue( t );

    BottomR = new QSpinBox( GroupBox7, "BottomR" );
    BottomR->setGeometry( QRect( 63, 39, 70, 20 ) ); 
    BottomR->setSuffix( tr( " mm" ) );
    BottomR->setMaxValue( 1000 );
    BottomR->setValue( b );

    LeftR = new QSpinBox( GroupBox7, "LeftR" );
    LeftR->setGeometry( QRect( 202, 15, 70, 20 ) ); 
    LeftR->setSuffix( tr( " mm" ) );
    LeftR->setMaxValue( 1000 );
    LeftR->setValue( l );

    RightR = new QSpinBox( GroupBox7, "RightR" );
    RightR->setGeometry( QRect( 202, 39, 70, 20 ) ); 
    RightR->setSuffix( tr( " mm" ) );
    RightR->setMaxValue( 1000 );
    RightR->setValue( r );

    Doppelseiten = new QCheckBox( GroupBox7, "Doppelseiten" );
    Doppelseiten->setGeometry( QRect( 89, 66, 142, 18 ) ); 
    Doppelseiten->setText( tr( "Facing Pages" ) );
    Doppelseiten->setChecked( fp );
    Links = new QLabel( GroupBox7, "Links" );
    Links->setGeometry( QRect( 144, 15, 51, 20 ) ); 
    Links->setText( tr( "Left:" ) );

    Rechts = new QLabel( GroupBox7, "Rechts" );
    Rechts->setGeometry( QRect( 144, 39, 51, 20 ) ); 
    Rechts->setText( tr( "Right:" ) );

    OKButton = new QPushButton( this, "OKButton" );
    OKButton->setGeometry( QRect( 40, 105, 86, 29 ) ); 
    OKButton->setText( tr( "OK" ) );
    OKButton->setDefault( TRUE );

    CancelB = new QPushButton( this, "CancelB" );
    CancelB->setGeometry( QRect( 170, 108, 86, 25 ) ); 
    CancelB->setText( tr( "Cancel" ) );
    CancelB->setAutoDefault( FALSE );

    // signals and slots connections
    connect( Doppelseiten, SIGNAL( clicked() ), this, SLOT( setDS() ) );
    connect( OKButton, SIGNAL( clicked() ), this, SLOT( accept() ) );
    connect( CancelB, SIGNAL( clicked() ), this, SLOT( reject() ) );
}

/*  
 *  Destroys the object and frees any allocated resources
 */
ReformDoc::~ReformDoc()
{
    // no need to delete child widgets, Qt does it all for us
}

void ReformDoc::setDS()
{
    if (Doppelseiten->isChecked())
    	{
    	Links->setText( tr( "Inside:" ) );
    	Rechts->setText( tr( "Outside:" ) );    	
    	}
    else
    	{
    	Links->setText( tr( "Left:" ) );
    	Rechts->setText( tr( "Right:" ) );
    	}
}

