/***************************************************************************
                          scribusdoc.h  -  description
                             -------------------
    begin                : Fre Apr  6 21:47:55 CEST 2001
    copyright            : (C) 2001 by Franz Schmid
    email                : Franz.Schmid@altmuehlnet.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef SCRIBUSDOC_H
#define SCRIBUSDOC_H

// include files for QT
#include <qobject.h>
#include <qdict.h>
#include <qcolor.h>
#include <qlist.h>
#include <qfont.h>
#include <qmap.h>
#include <qpointarray.h>
class Page;

/* Struktur fr Pageitem Text */
struct Pti { int ch;
				     float xp;
				     float yp;
				     int csize;
				     QString cfont;
				     QString ccolor;
				     bool cselect;
				     float cextra;
				     int cshade;
				    };
				
struct CLBuf { int PType;
							 float Xpos;
							 float Ypos;
							 float Width;
							 float Height;
							 int Pwidth;
							 QString Pcolor;
							 QString Pcolor2;
							 int Shade;
							 int Shade2;
							 float Rot;
							 int PLineArt;
							 float LineSp;
							 float LocalScX;
							 float LocalScY;
							 float LocalX;
							 float LocalY;
							 bool PicArt;
							 int flippedH;
							 int flippedV;
							 float BBoxX;
							 float BBoxH;
							 bool isPrintable;
							 bool isBookmark;
							 bool Transparent;
							 float Extra;
							 QString Pfile;
							 QString Ptext;
							 QPointArray Clip;
							};

struct Foi { QString Datei;
						 QFont Font;
						 QString RealName;
						 bool EmbedPS;
						};
						
typedef QMap<QString,Foi> SCFonts;
							
/** Definition der Farbenlisten */
typedef QMap<QString,QColor> CListe;
/**
  * the Document Class
  */

class ScribusDoc : public QObject
{

public:
    ScribusDoc();
    ~ScribusDoc();
    void setModified();
    void setUnModified();
    bool isModified() const;
  /** Setzt die Seitenattribute */
  void setPage(float b, float h, float t, float l, float r, float bo, float sp, float ab, bool atf, bool fp);
  void resetPage(float t, float l, float r, float bo, bool fp);
  void AddFont(QString name, QFont fo);
  protected:
    bool modified;
	public: // Public attributes
  /** Vergrerungsfaktor fr das Dokument */
  float Scale;
  bool Marks;
  bool loading;
  /** Breite der Seite  */
  float PageB;
  /** Hhe der Seite */
  float PageH;
  /** Anzahl der Seiten */
  int PageC;
  /** Seitenrnder */
  struct { float Top;
           float Left;
           float Right;
           float Bottom;
          } PageM;
  /** Anzahl der Spalten */
  float PageSp;
  /** Abstand der Spalten */
  float PageSpa;
  /** Flag fr AutoTextrahmen */
  bool PageAT;
  /** Flag fr Doppelseiten */
  bool PageFP;
  /** Flag fr Raster */
  bool Raster;
  /** Flag fr Rasterbenutzung */
  bool useRaster;
  /** Flag fr Bilder */
  bool ShowPic;
  /** Im Dokument benutzte Farben */
  CListe PageColors;
  Page* ActPage;
  /** InfoStrings fr das aktuelle Dokument */
  QString DocAutor;
  QString DocTitel;
  QString DocComments;
  int AppMode;
  QString Dpen;
  QString Dbrush;
  int Dwidth;
  int Dshade;
  int Dshade2;
  PenStyle DLineArt;
  QString Dfont;
  QString DocName;
  QMap<QString,QFont> UsedFonts;
  int Dsize;
  QColor minorColor;
  QColor majorColor;
  int minorGrid;
  int majorGrid;
  int CurrentSel;
  bool EditClip;
};

#endif
