/***************************************************************************
                          scribusview.h  -  description
                             -------------------
    begin                : Fre Apr  6 21:47:55 CEST 2001
    copyright            : (C) 2001 by Franz Schmid
    email                : Franz.Schmid@altmuehlnet.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SCRIBUSVIEW_H
#define SCRIBUSVIEW_H

// include files for QT
#include <qscrollview.h>
#include <qlist.h>
#include <qlineedit.h>
#include <qscrollbar.h>
#include <qpushbutton.h>
#include <qpopupmenu.h>
//#include <iostream.h>
// application specific includes
#include "scribusdoc.h"
#include "page.h"
#include "hruler.h"
#include "vruler.h"
#include "pslib.h"

/**
 * This class provides an incomplete base for your application view. 
 */

class ScribusView : public QScrollView
{
  Q_OBJECT
  public:
    ScribusView(QWidget *parent=0, ScribusDoc *doc=0);
    ~ScribusView();
  /** Liste der Seiten */
  QList<Page> Pages;
  /** Fgt eine Seite hinzu */
  Page* addPage();
  /** Lscht eine Seite */
  void delPage(int Nr);
  void reformPages();
  QString CreatePS(PSLib *p, uint von, uint bis, int step);
  /** Dokument zu dem die Seite gehrt */
  ScribusDoc *Doc;

public slots: // Public slots
  /** Fhrt die Vergrerung/Verkleinerung aus; */
  void slotDoZoom();
  /** Vergrert die Ansicht */
  void slotZoomIn();
  /** Verkleinert die Ansicht */
  void slotZoomOut();
  /** Zeichnet alle Seiten neu */
  void DrawNew();
  void setMenTxt(int Seite);
  void GotoPa(int Seite);
  void GotoPage(int Seite);
private: // Private attributes
  /** Vergroesserungseingabefeld */
  QLineEdit *LE;
  QPushButton *SB1;
  QPushButton *SB2;
  QPushButton *LA;
  QPopupMenu *Seitmen;
  Hruler *HR;
  Vruler *VR;
  bool Ready;
  void PaMenu();
private slots:
  void Zval();
  void setRulerPos(int x, int y);
protected: // Protected methods
  /** Waagrechter Scrollbalken */
	virtual void setHBarGeometry(QScrollBar &bar, int x, int y, int w, int h);
	virtual void setVBarGeometry(QScrollBar &bar, int x, int y, int w, int h);
};
#endif
