#include "tools.h"
#include "icons3.h"

Tools::Tools( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "Tools" );
    resize( 35, 308 ); 
    setMinimumSize( QSize( 35, 308 ) );
    setMaximumSize( QSize( 35, 308 ) );
    setCaption( tr( "Tools" ) );

    TA = new FPaletteV( this, 1, 1, 1 );

    ButtonGroup2 = new QButtonGroup( this, "ButtonGroup2" );
    ButtonGroup2->setGeometry( QRect( 1, 13, 33, 294 ) ); 
    ButtonGroup2->setFrameShape( QButtonGroup::NoFrame );
    ButtonGroup2->setFrameShadow( QButtonGroup::Plain );
    ButtonGroup2->setTitle( tr( "" ) );
    ButtonGroup2->setExclusive( TRUE );

    Select = new QToolButton( ButtonGroup2, "Select" );
    Select->setGeometry( QRect( 2, 2, 29, 29 ) ); 
    Select->setText( tr( "" ) );
    Select->setPixmap( QPixmap(Kreuz) );
    Select->setToggleButton( TRUE );
    Select->setOn( TRUE );

    Textedit = new QToolButton( ButtonGroup2, "Textedit" );
    Textedit->setGeometry( QRect( 2, 66, 29, 29 ) ); 
    Textedit->setText( tr( "" ) );
    Textedit->setPixmap( QPixmap(Editm) );
    Textedit->setToggleButton( TRUE );
		Textedit->setEnabled( FALSE );

    Zoom = new QToolButton( ButtonGroup2, "Zoom" );
    Zoom->setGeometry( QRect( 2, 98, 29, 29 ) ); 
    Zoom->setText( tr( "" ) );
    Zoom->setPixmap( QPixmap(Lupe) );
    Zoom->setToggleButton( TRUE );

    Texte = new QToolButton( ButtonGroup2, "Texte" );
    Texte->setGeometry( QRect( 2, 134, 29, 29 ) ); 
    Texte->setText( tr( "" ) );
    Texte->setPixmap( QPixmap(Text) );
    Texte->setToggleButton( TRUE );

    Bilder = new QToolButton( ButtonGroup2, "Bilder" );
    Bilder->setGeometry( QRect( 2, 166, 29, 29 ) ); 
    Bilder->setText( tr( "" ) );
    Bilder->setPixmap( QPixmap(Bild) );
    Bilder->setToggleButton( TRUE );

    Linien = new QToolButton( ButtonGroup2, "Linien" );
    Linien->setGeometry( QRect( 2, 262, 29, 29 ) ); 
    Linien->setText( tr( "..." ) );
    Linien->setPixmap( QPixmap(Stift) );
    Linien->setToggleButton( TRUE );

    Kreis = new QToolButton( ButtonGroup2, "Kreis" );
    Kreis->setGeometry( QRect( 2, 230, 29, 29 ) ); 
    Kreis->setText( tr( "..." ) );
    Kreis->setPixmap( QPixmap(Kreise) );
    Kreis->setToggleButton( TRUE );

    Rechteck = new QToolButton( ButtonGroup2, "Rechteck" );
    Rechteck->setGeometry( QRect( 2, 198, 29, 29 ) ); 
    Rechteck->setText( tr( "" ) );
    Rechteck->setPixmap( QPixmap(Rechtecke) );
    Rechteck->setToggleButton( TRUE );

    Rotiere = new QToolButton( ButtonGroup2, "Rotiere" );
    Rotiere->setGeometry( QRect( 2, 34, 29, 29 ) ); 
    Rotiere->setText( tr( "" ) );
    Rotiere->setPixmap( QPixmap(Rotieren) );
    Rotiere->setToggleButton( TRUE );

    // signals and slots connections
    connect( Select, SIGNAL( clicked() ), this, SLOT( slotSelect() ) );
    connect( Rotiere, SIGNAL( clicked() ), this, SLOT( slotRotate() ) );
    connect( Textedit, SIGNAL( stateChanged(int) ), this, SLOT( slotEdit() ) );
    connect( Zoom, SIGNAL( clicked() ), this, SLOT( slotZoom() ) );
    connect( Texte, SIGNAL( clicked() ), this, SLOT( slotText() ) );
    connect( Bilder, SIGNAL( stateChanged(int) ), this, SLOT( slotImage() ) );
    connect( Rechteck, SIGNAL( clicked() ), this, SLOT( slotRect() ) );
    connect( Kreis, SIGNAL( clicked() ), this, SLOT( slotEllipse() ) );
    connect( Linien, SIGNAL( clicked() ), this, SLOT( slotLine() ) );
}

/*  
 *  Destroys the object and frees any allocated resources
 */
Tools::~Tools()
{
    // no need to delete child widgets, Qt does it all for us
}

void Tools::paintEvent(QPaintEvent *)
{	
	QPainter p;
	p.begin(this);
	p.setPen(black);
	p.setBrush(NoBrush);
	p.drawRect(0, 0, 35, 308);
	p.end();
}

void Tools::slotRotate()
{
    emit SetMode(9);
}

void Tools::slotEdit()
{
    emit SetMode(7);
}

void Tools::slotEllipse()
{
    emit SetMode(3);
}

void Tools::slotImage()
{
		emit SetMode(4);
}

void Tools::slotLine()
{
    emit SetMode(8);
}

void Tools::slotRect()
{
    emit SetMode(2);
}

void Tools::slotSelect()
{
    Select->setOn( TRUE );
    emit SetMode(1);
}

void Tools::slotText()
{
    emit SetMode(5);
}

void Tools::slotZoom()
{
    emit SetMode(6);
}

