#ifndef TOOLS_H
#define TOOLS_H

#include <qvariant.h>
#include <qdialog.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qbuttongroup.h>
#include <qlabel.h>
#include <qtoolbutton.h>
#include <qlayout.h>
#include <qpainter.h>
#include "fpalettev.h"

class Tools : public QDialog
{ 
    Q_OBJECT

public:
    Tools( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~Tools();

    FPaletteV* TA;
    void paintEvent(QPaintEvent *);
    QButtonGroup* ButtonGroup2;
    QToolButton* Select;
    QToolButton* Textedit;
    QToolButton* Zoom;
    QToolButton* Texte;
    QToolButton* Bilder;
    QToolButton* Linien;
    QToolButton* Kreis;
    QToolButton* Rechteck;
    QToolButton* Rotiere;

public slots:
    virtual void slotRotate();
    virtual void slotEdit();
    virtual void slotEllipse();
    virtual void slotImage();
    virtual void slotLine();
    virtual void slotRect();
    virtual void slotSelect();
    virtual void slotText();
    virtual void slotZoom();

signals: // Signals
  /** Setzt den Appmode */
  void SetMode(int);
};

#endif // TOOLS_H
