/***************************************************************************
                          vruler.cpp  -  description
                             -------------------
    begin                : Wed Apr 11 2001
    copyright            : (C) 2001 by Franz Schmid
    email                : Franz.Schmid@altmuehlnet.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "vruler.h"

Vruler::Vruler(QScrollView *pa, ScribusDoc *doc) : QWidget(pa)
{
	setBackgroundColor(QColor(255,255,255));
	doku = doc;
	rfont = font();
	rfont.setPointSize(9);
	offs = -12;
	Markp = 0;
	repY = FALSE;
}
Vruler::~Vruler(){
}

void Vruler::paintEvent(QPaintEvent *)
{
	int ende, xx, xl, of;
	float sc = doku->Scale;
	QPainter p;
	p.begin(this);
	p.translate(0, -offs);
	if (repY)
		{
		p.setPen(red);
		p.setBrush(red);
		QPointArray cr;
		cr.setPoints(3, 9, Markp, 0, Markp+2, 0, Markp-2);
		p.drawPolygon(cr);
		p.end();
		repY = FALSE;
		return;
		}
	p.setBrush(black);
	p.setPen(black);
	p.setFont(rfont);
	p.scale(1.0, sc);
	ende = qRound((doku->PageH+5)*doku->PageC+10*sc+25*(doku->PageC-1));
	p.drawLine(24, 0, 24, ende);
	for (xx = 0; xx < doku->PageC; xx++)
		{
		of = qRound(xx * (doku->PageH+30));
		for (xl = 0; xl < doku->PageH; xl += 10)
			{
			if (xl % 100 == 0)
				{
				p.drawLine(11, xl+of, 24, xl+of);
				p.save();
				p.scale(1.0, 1.0 / sc);
				p.drawText(9, (xl+of+qRound(10/sc)) * sc, QString::number(xl));
				p.restore();
				}
			else
				{
				p.drawLine(18, xl+of, 24, xl+of);
				}
			}
		}
	p.end();
}
/** Zeichnet den Pfeil */
void Vruler::Draw(int wo)
{
	repY = TRUE;
	Markp = wo-qRound(10*doku->Scale);
	repaint(QRect(0, 0, 9, height()));
}

